#include <stdlib.h>
#include <fstream>
#include <iostream>

using namespace std;

struct point /// ,     
{
    double x, y;

};

class func ///  
{
private:
    double a, b, dx; ///, ,   
    int n;///- 
    point* mas;///   
public:/// 
    func(double _a, double _b, double _dx):a(_a), b(_b), dx(_dx) ///   
    {
        n = (int)((b - a) / dx) + 1; /// - 
        mas = new point[n];///  
        for(int i = 0; i < n; i++) ///   
            mas[i].x = a + i * dx;
    }
    ~func() {} ///

    func () /// 
    {
    }

    void input () ///      
    {
        char s [100] ;///    
        cin >> s; ///   ,   
        ifstream fin(s);
        fin >> n;
        mas = new point[n];///  

        if(fin.is_open()) ///   ,     
        {
            for(int i = 0; i < n; i++)
            {
                fin >> mas[i].x >> mas[i].y; ///    
            }
        }
        fin.close();/// 
        a=mas[0].x; /// 
        b=mas[n-1].x; ///
        dx=(b - a+ 1)/n ;/// 
    }

    void output ()///    
    {
        char s [100] ;///    
        cin >> s;
        ofstream fout(s); /// 
        for(int i = 0; i < n; i++) ///        
        {
            fout << mas[i].x << " ";///  
            fout << mas[i].y << "\n";///  
        }
        fout.close();/// 
    }

    func Inter(double k) /// 
    {
        func res(a, b, k); ///    ,   
        int j=0;
        for(int i = 0; i < res.n; i++)
        {
            if(res.mas[i].x == mas[j].x)
            {
                res.mas[i].y = mas[j].y;
                j++;
            }
            else
            {
                double alpha = (mas[j].y - mas[j - 1].y) / (mas[j].x - mas[j - 1].x); ///  
                res.mas[i].y = alpha * (res.mas[i].x - mas[j - 1].x) + mas[j - 1].y;///   
            }
        }
        return res;
    }

    func Approxy() /// 
    {
        func res(a, b, dx); ///    ,    
        double sum[5], a, b; ///,  ,     ( 0  5,    5 )

        for (int i = 0; i < 5; i++)///- 
            sum[i] = 0;

        for (int i = 0; i < n; i++) ///,   (   0,1,2,3,4,5)
        {
            sum[0] += mas[i].x * mas[i].y;
            for (int j = 0; j < n; j++)
                sum[1] += mas[i].x * mas[j].y;
            sum[2] += mas[i].x * mas[i].x;
            sum[3] += mas[i].x;
            sum[4] += mas[i].y;
        }
        a = (n * sum[0] - sum[1]) / (n * sum[2] - sum[3] * sum[3]); /// 
        b = (sum[4] - a * sum[3]) / n; /// 

        for ( int i = 0; i < n; i++) /// ,       
            res.mas[i].y = a * res.mas[i].x + b;
        return res;
    }

    func operator+ (func &A) ///  
    {
        int beg,en; ///     
        int k,resn; ///  

        if (mas[0].x < A.mas[0].x)
        {
            beg = A.mas[0].x;
            for (k = 0; beg != mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;
            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i+k].y + A.mas[i].y; ///    ()
            return res;
        }
        else
        {
            beg = mas[0].x;
            for (k = 0; beg != A.mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;

            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i].y + A.mas[i+k].y; ///   ()
            return res;
        }
    }

    func operator- (func &A) ///  
    {
        int beg,en;
        int k,resn;

        if (mas[0].x < A.mas[0].x)
        {
            beg = A.mas[0].x;
            for (k = 0; beg != mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;
            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i+k].y - A.mas[i].y; ///    ()
            return res;
        }
        else
        {
            beg = mas[0].x;
            for (k = 0; beg != A.mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;

            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i].y - A.mas[i+k].y; ///   ()
            return res;
        }
    }

    func operator* (func &A) ///  
    {
        int beg,en;
        int k,resn;

        if (mas[0].x < A.mas[0].x)
        {
            beg = A.mas[0].x;
            for (k = 0; beg != mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;
            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i+k].y * A.mas[i].y; ///    ()
            return res;
        }
        else
        {
            beg = mas[0].x;
            for (k = 0; beg != A.mas[k].x; k++);

            if (mas[n-1].x < A.mas[A.n - 1].x)
                en = mas[n-1].x;
            else
                en = A.mas[A.n - 1].x;

            resn = (en - beg)/dx + 1;

            func res(beg,en,dx);
            for(int i = 0; i < resn; i++)
                res.mas[i].y = mas[i].y * A.mas[i+k].y; ///   ()
            return res;
        }
    }

};

int main() /// 
{
    int p = 0;
    func newf1,newf2,newf3,newf4,newf5; ///,    ,    
    while(1)
    {
        system("cls");
        ///   
        cout << "1 - Vvesti pervuu function"                                               << endl;///    ,   
        cout << "2 - Vvesti vtoruu function"                                               << endl;///    ,   
        cout << "3 - Slozhit' function"                                                    << endl;///  ,    
        cout << "4 - Vichest' function"                                                    << endl;///  ,    
        cout << "5 - Umnozhit' function"                                                   << endl;///  ,    
        cout << "6 - Interpolirovat' function, kotoraya poluchilas' v rezultate slozhenia" << endl;///  ,    
        cout << "7 - Aproksimirovat' function, kotoraya poluchilas' v rezultate slozhenia" << endl;///  ,    
        cout << "8 - Vihod"                                                                << endl;
        cin >> p;                                                              ///  
        switch (p)
        {
        case 1:
            newf1.input();
            break;
        case 2:
            newf2.input();
            break;
        case 3:
            newf3 = newf1 + newf2;
            newf3.output();
            break;
        case 4:
            newf4 = newf1 - newf2;
            newf4.output();
            break;
        case 5:
            newf5 = newf1 * newf2;
            newf5.output();
            break;
        case 6:
            newf3.Inter(0.5).output();
            break;
        case 7:
            newf3.Approxy().output();
            break;
        case 8:
            return 0;

        }
    }
}
